local D = AceLibrary("Dewdrop-2.0")
local L = AceLibrary("AceLocale-2.2"):new("ImprovedTargetFrame")
ITF = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
ITF:RegisterDB("ImprovedTargetFrame", "ImprovedTargetFrame")
ITF:RegisterDefaults("profile", {   menu = true,
                                    class_enemy_npc = true,
                                    class_friend_npc = false,
                                    class_enemy_player = true,
                                    class_friend_player = true,
                                    class_level = 5,
                                    class_x = 125,
                                    class_y = 80,
                                    class_size = 60,
                                    class_color = {1, 1, 1, 1},
                                    string_enemy_guild = true,
                                    string_friend_guild = true,
                                    string_enemy_typ = true,
                                    string_friend_typ = false,
                                    string_familie = true,
                                    string_lenght = 18,
                                    string_size = 11,
                                    string_font = 4,
                                    string_color = {1, 1, 0, 1},
                                    string_x = 16,
                                    string_y = 88,
                                    } )
-- gui elements
local f = iti_texture_frame
local t = iti_texture
local s = iti_string

function ITF:OnInitialize()
    -- options table
    local options = {
            type = 'group',
            desc = "Class Icon Options",
            args = {
                header1 = {
                    order = 1,
                    type = 'header',
                    name = L["Header1"],
                },
                menu = {
                    order = 2,
                    type = 'toggle',
                    name = L["Menu-Name"],
                    desc = L["Menu-Desc"],
                    get = function() return self.db.profile.menu end,
                    set = function() self.db.profile.menu = not self.db.profile.menu; self:OnUpdate(); end,
                },
                header2 = {
                    order = 3,
                    type = 'header',
                    name = L["Header2"],
                },
                class_enemy_npc = {
                    order = 4,
                    type = 'toggle',
                    name = L["Class-Show-Enemy-NPC-Name"],
                    desc = L["Class-Show-Enemy-NPC-Desc"],
                    get = function() return self.db.profile.class_enemy_npc end,
                    set = function() self.db.profile.class_enemy_npc = not self.db.profile.class_enemy_npc; self:OnUpdate(); end,
                },
                class_friend_npc = {
                    order = 5,
                    type = 'toggle',
                    name = L["Class-Show-Friend-NPC-Name"],
                    desc = L["Class-Show-Friend-NPC-Desc"],
                    get = function() return self.db.profile.class_friend_npc end,
                    set = function() self.db.profile.class_friend_npc = not self.db.profile.class_friend_npc; self:OnUpdate(); end,
                },
                class_enemy_player = {
                    order = 6,
                    type = 'toggle',
                    name = L["Class-Show-Enemy-Player-Name"],
                    desc = L["Class-Show-Enemy-Player-Desc"],
                    get = function() return self.db.profile.class_enemy_player end,
                    set = function() self.db.profile.class_enemy_player = not self.db.profile.class_enemy_player; self:OnUpdate(); end,
                },
                class_friend_player = {
                    order = 7,
                    type = 'toggle',
                    name = L["Class-Show-Friend-Player-Name"],
                    desc = L["Class-Show-Friend-Player-Desc"],
                    get = function() return self.db.profile.class_friend_player end,
                    set = function() self.db.profile.class_friend_player = not self.db.profile.class_friend_player; self:OnUpdate(); end,
                },
                class_level = {
                    order = 8,
                    type = 'range',
                    name = L["Class-Level-Name"],
                    desc = L["Class-Level-Desc"],
                    get = function() return self.db.profile.class_level end,
                    set = function(v) self.db.profile.class_level = v; self:OnUpdate(); end,
                    min = 0,
                    max = 5,
                    step = 1,
                },
                class_x = {
                    order = 9,
                    type = 'range',
                    name = L["Class-X-Name"],
                    desc = L["Class-X-Desc"],
                    get = function() return self.db.profile.class_x end,
                    set = function(v) self.db.profile.class_x = v; self:OnUpdate(); end,
                    min = 0,
                    max = 200,
                    step = 1,
                },
                class_y = {
                    order = 10,
                    type = 'range',
                    name = L["Class-Y-Name"],
                    desc = L["Class-Y-Desc"],
                    get = function() return self.db.profile.class_y end,
                    set = function(v) self.db.profile.class_y = v; self:OnUpdate(); end,
                    min = 0,
                    max = 120,
                    step = 1,
                },
                class_size = {
                    order = 11,
                    type = 'range',
                    name = L["Class-Size-Name"],
                    desc = L["Class-Size-Desc"],
                    get = function() return self.db.profile.class_size end,
                    set = function(v) self.db.profile.class_size = v; self:OnUpdate(); end,
                    min = 20,
                    max = 150,
                    step = 1,
                },
                class_color= {
                    order = 12,
                    type = 'color',
                    name = L["Class-Color-Name"],
                    desc = L["Class-Color-Desc"],
                    get = function() return self.db.profile.class_color[1], self.db.profile.class_color[2], self.db.profile.class_color[3], self.db.profile.class_color[4]; end,
                    set = function(r, g, b, a) self.db.profile.class_color = {r, g, b, a}; self:OnUpdate(); end,
                    hasAlpha = true,
                },
                header3 = {
                    order = 13,
                    type = 'header',
                    name = L["Header3"],
                },
                string_enemy_guild = {
                    order = 14,
                    type = 'toggle',
                    name = L["String-Show-Enemy-Guild-Name"],
                    desc = L["String-Show-Enemy-Guild-Desc"],
                    get = function() return self.db.profile.string_enemy_guild end,
                    set = function() self.db.profile.string_enemy_guild = not self.db.profile.string_enemy_guild; self:OnUpdate(); end,
                },
                string_friend_guild = {
                    order = 15,
                    type = 'toggle',
                    name = L["String-Show-Friend-Guild-Name"],
                    desc = L["String-Show-Friend-Guild-Desc"],
                    get = function() return self.db.profile.string_friend_guild end,
                    set = function() self.db.profile.string_friend_guild = not self.db.profile.string_friend_guild; self:OnUpdate(); end,
                },
                string_enemy_typ = {
                    order = 16,
                    type = 'toggle',
                    name = L["String-Show-Enemy-Typ-Name"],
                    desc = L["String-Show-Enemy-Typ-Desc"],
                    get = function() return self.db.profile.string_enemy_typ end,
                    set = function() self.db.profile.string_enemy_typ = not self.db.profile.string_enemy_typ; self:OnUpdate(); end,
                },
                string_friend_typ = {
                    order = 17,
                    type = 'toggle',
                    name = L["String-Show-Friend-Typ-Name"],
                    desc = L["String-Show-Friend-Typ-Desc"],
                    get = function() return self.db.profile.string_friend_typ end,
                    set = function() self.db.profile.string_friend_typ = not self.db.profile.string_friend_typ; self:OnUpdate(); end,
                },
                string_familie = {
                    order = 18,
                    type = 'toggle',
                    name = L["String-Show-Familie-Name"],
                    desc = L["String-Show-Familie-Desc"],
                    get = function() return self.db.profile.string_familie end,
                    set = function() self.db.profile.string_familie = not self.db.profile.string_familie; self:OnUpdate(); end,
                },
                string_lenght = {
                    order = 19,
                    type = 'range',
                    name = L["String-Lenght-Name"],
                    desc = L["String-Lenght-Desc"],
                    get = function() return self.db.profile.string_lenght end,
                    set = function(v) self.db.profile.string_lenght = v; self:OnUpdate(); end,
                    min = 6,
                    max = 40,
                    step = 1,
                },
                string_font = {
                    order = 20,
                    type = 'range',
                    name = L["String-Font-Name"],
                    desc = L["String-Font-Desc"],
                    get = function() return self.db.profile.string_font end,
                    set = function(v) self.db.profile.string_font = v; self:OnUpdate(); end,
                    min = 1,
                    max = 12,
                    step = 1,
                },
                string_size = {
                    order = 21,
                    type = 'range',
                    name = L["String-Size-Name"],
                    desc = L["String-Size-Desc"],
                    get = function() return self.db.profile.string_size end,
                    set = function(v) self.db.profile.string_size = v; self:OnUpdate(); end,
                    min = 4,
                    max = 36,
                    step = 1,
                },
                string_x = {
                    order = 22,
                    type = 'range',
                    name = L["String-X-Name"],
                    desc = L["String-X-Desc"],
                    get = function() return self.db.profile.string_x end,
                    set = function(v) self.db.profile.string_x = v; self:OnUpdate(); end,
                    min = 0,
                    max = 200,
                    step = 1,
                },
                string_y = {
                    order = 23,
                    type = 'range',
                    name = L["String-Y-Name"],
                    desc = L["String-Y-Desc"],
                    get = function() return self.db.profile.string_y end,
                    set = function(v) self.db.profile.string_y = v; self:OnUpdate(); end,
                    min = 0,
                    max = 120,
                    step = 1,
                },
                string_color= {
                    order = 24,
                    type = 'color',
                    name = L["String-Color-Name"],
                    desc = L["String-Color-Desc"],
                    get = function() return self.db.profile.string_color[1], self.db.profile.string_color[2], self.db.profile.string_color[3], self.db.profile.string_color[4]; end,
                    set = function(r, g, b, a) self.db.profile.string_color = {r, g, b, a}; self:OnUpdate(); end,
                    hasAlpha = true,
                },
            },

    }
    ITF:RegisterChatCommand(L["Slash-Commands"], options)
    self:RegisterEvent("PLAYER_TARGET_CHANGED")
    -- ui elements
    f = CreateFrame("Frame", f)
    f:SetParent("TargetFrame")
    t = f:CreateTexture(t, "OVERLAY")
    t:SetAllPoints(f)
    s = TargetFrame:CreateFontString(s, "OVERLAY")
    -- dewdrop
	D:Register(f,
		'children', function()
			D:FeedAceOptionsTable(options)
		end,
		'point', function(parent)
    		if parent:GetTop() < GetScreenHeight() / 2 then
    			return 'BOTTOM', 'TOP'
            else
    			return 'TOP', 'BOTTOM'
    		end
		end,
		'cursorX', true
	)

    self:OnUpdate()
end

function ITF:PLAYER_TARGET_CHANGED()
    if TargetFrame:IsShown() then
        -- player
        if UnitIsPlayer("target") then
            if UnitIsFriend("player","target") then
                if self.db.profile.class_friend_player then
                    self:ClassIconShow()
                end
                if self.db.profile.string_friend_guild then
                    self:GuildShow()
                end
            elseif not UnitIsFriend("player","target") then
                if self.db.profile.class_enemy_player then
                    self:ClassIconShow()
                end
                if self.db.profile.string_enemy_guild then
                    self:GuildShow()
                end
            else
                f:Hide()
                s:Hide()
            end
        -- npc
        elseif UnitIsFriend("player","target") then
            if self.db.profile.class_friend_npc then
                self:ClassIconShow()
            else
                f:Hide()
            end
            if self.db.profile.string_friend_typ then
                self:TypShow()
            else
                s:Hide()
            end
        elseif not UnitIsFriend("player","target") then
            if self.db.profile.class_enemy_npc then
                self:ClassIconShow()
            else
                f:Hide()
            end
            if self.db.profile.string_enemy_typ then
                self:TypShow()
            else
                s:Hide()
            end
        else
            f:Hide()
            s:Hide()
        end
    end
end

function ITF:ClassIconShow()
    local _, class = UnitClass("target")
    if (class == "WARRIOR" or "DRUID" or "WARLOCK" or "MAGE" or "PRIEST" or "ROGUE" or "HUNTER" or "PALADIN" or "SHAMAN") then
        t:SetTexture("Interface\\AddOns\\ImprovedTargetFrame\\texturen\\"..class)
    end
    f:Show()
end

function ITF:GuildShow()
    if GetGuildInfo("target") ~= nil then
        s:SetText(GetGuildInfo("target"))
        self:StringLenghtUpdate()
    else
        s:Hide()
    end
end

function ITF:TypShow()
    local fam = ""
    if self.db.profile.string_familie and UnitCreatureFamily("target") ~= nil then
        s:SetText(UnitCreatureType("target").." ("..UnitCreatureFamily("target")..")")
    else
        s:SetText(UnitCreatureType("target"))
    end
    self:StringLenghtUpdate()
end

function ITF:StringLenghtUpdate()
    if s:GetText() ~= nil or "" then
        if strlen(s:GetText())>self.db.profile.string_lenght then
            s:SetText((strsub(s:GetText(), 0, self.db.profile.string_lenght-3)).."...")
        end
        s:Show()
    end
end

function ITF:OnUpdate()

    -- class icon
    f:SetPoint("CENTER", "TargetFrame", "BOTTOMLEFT", self.db.profile.class_x, self.db.profile.class_y)
    f:SetHeight(self.db.profile.class_size)
	f:SetWidth(self.db.profile.class_size)
    f:SetFrameLevel(self.db.profile.class_level)
    if self.db.profile.menu then
        TargetFrame:SetScript("OnMouseDown", function() if (arg1 == "LeftButton") then D:Open(f) end end)
    else
        TargetFrame:SetScript("OnMouseDown", function() end)
    end
	t:SetVertexColor(self.db.profile.class_color[1], self.db.profile.class_color[2], self.db.profile.class_color[3], self.db.profile.class_color[4])

    --fonts
    local fontlist = {
        "Fonts\\ARIALN.TTF",
        "Fonts\\FRIZQT__.TTF",
        "Fonts\\MORPHEUS.TTF",
        "Fonts\\skurri.ttf",
        }
    local fontback = {
        nil,
        "OUTLINE, THICKOUTLINE",
        "OUTLINE, MONOCHROME",
        }
    local font = {1,1}
    if self.db.profile.string_font == 2 then
        font = {1,2}
    elseif self.db.profile.string_font == 3 then
        font = {1,3}
    elseif self.db.profile.string_font == 4 then
        font = {2,1}
    elseif self.db.profile.string_font == 5 then
        font = {2,2}
    elseif self.db.profile.string_font == 6 then
        font = {2,3}
    elseif self.db.profile.string_font == 7 then
        font = {3,1}
    elseif self.db.profile.string_font == 8 then
        font = {3,2}
    elseif self.db.profile.string_font == 9 then
        font = {3,3}
    elseif self.db.profile.string_font == 10 then
        font = {4,1}
    elseif self.db.profile.string_font == 11 then
        font = {4,2}
    elseif self.db.profile.string_font == 12 then
        font = {4,3}
    end

    -- string
    s:SetPoint("LEFT", "TargetFrame", "BOTTOMLEFT", self.db.profile.string_x, self.db.profile.string_y)
    s:SetFont(fontlist[font[1]], self.db.profile.string_size, fontback[font[2]])
    s:SetTextColor(self.db.profile.string_color[1], self.db.profile.string_color[2], self.db.profile.string_color[3], self.db.profile.string_color[4])
    s:SetText("Test text HAHA 123")
    self:PLAYER_TARGET_CHANGED()
end
